#include <stdio.h>
#include <stdlib.h>

int square_adder (int start, int end) {
  int i;
  int sum = 0;
  for (i = start; i < end; i++) {
    sum += i * i;
  }
  return sum;
} 

int main () {
  // Loesung mit Prozessen
  int pipe1[2]; pipe (pipe1);
  int pipe2[2]; pipe (pipe2);

  // Kind 1
  if (fork() == 0) {
    // Kind
    close (pipe1[0]);   // close read end
    int res = square_adder(1, 51);
    write (pipe1[1], &res, sizeof(res));
    exit (0);
  }

  // Kind 2
  if (fork() == 0) {
    // Kind
    close (pipe2[0]);   // close read end
    int res = square_adder(51, 101);
    write (pipe2[1], &res, sizeof(res));
    exit (0);
  }

  // Vater
  int res1, res2;
  close (pipe1[1]);   // close write end
  close (pipe2[1]);   // close write end
  read (pipe1[0], &res1, sizeof(res1));
  read (pipe2[0], &res2, sizeof(res2));

  printf ("p1 returns %d\n", res1);
  printf ("p2 returns %d\n", res2);
  printf ("total sum: %d\n", res1 + res2);

  printf ("Kontrolle: %d\n", square_adder (1, 101));
}
